<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: WebSocketInputStreambuf Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classWebSocketInputStreambuf-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">WebSocketInputStreambuf Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for WebSocketInputStreambuf:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classWebSocketInputStreambuf.png" alt=""/>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a89ecd4bd0c30e8681bce57217b107502"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWebSocketInputStreambuf.html#a89ecd4bd0c30e8681bce57217b107502">WebSocketInputStreambuf</a> (<a class="el" href="classSocket.html">Socket</a> socket, size_t dataLength, uint8_t *pMask=nullptr, size_t bufferSize=2048)</td></tr>
<tr class="memdesc:a89ecd4bd0c30e8681bce57217b107502"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a Web <a class="el" href="classSocket.html" title="Encapsulate a socket.">Socket</a> input record streambuf.  <a href="#a89ecd4bd0c30e8681bce57217b107502">More...</a><br /></td></tr>
<tr class="separator:a89ecd4bd0c30e8681bce57217b107502"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2452c9871aa4c0404e773d6b7dc02cb"><td class="memItemLeft" align="right" valign="top"><a id="ab2452c9871aa4c0404e773d6b7dc02cb"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWebSocketInputStreambuf.html#ab2452c9871aa4c0404e773d6b7dc02cb">~WebSocketInputStreambuf</a> ()</td></tr>
<tr class="memdesc:ab2452c9871aa4c0404e773d6b7dc02cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:ab2452c9871aa4c0404e773d6b7dc02cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed7065a593c58510569031142ce62e94"><td class="memItemLeft" align="right" valign="top">int_type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWebSocketInputStreambuf.html#aed7065a593c58510569031142ce62e94">underflow</a> ()</td></tr>
<tr class="memdesc:aed7065a593c58510569031142ce62e94"><td class="mdescLeft">&#160;</td><td class="mdescRight">Handle the request to read data from the stream but we need more data from the source.  <a href="#aed7065a593c58510569031142ce62e94">More...</a><br /></td></tr>
<tr class="separator:aed7065a593c58510569031142ce62e94"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af91a50709423669d4ade7713a612dc64"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWebSocketInputStreambuf.html#af91a50709423669d4ade7713a612dc64">discard</a> ()</td></tr>
<tr class="memdesc:af91a50709423669d4ade7713a612dc64"><td class="mdescLeft">&#160;</td><td class="mdescRight">Discard data for the record that has not yet been read.  <a href="#af91a50709423669d4ade7713a612dc64">More...</a><br /></td></tr>
<tr class="separator:af91a50709423669d4ade7713a612dc64"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cf5dcebbeefc1670767ac619472e0bb"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWebSocketInputStreambuf.html#a8cf5dcebbeefc1670767ac619472e0bb">getRecordSize</a> ()</td></tr>
<tr class="memdesc:a8cf5dcebbeefc1670767ac619472e0bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the size of the expected record.  <a href="#a8cf5dcebbeefc1670767ac619472e0bb">More...</a><br /></td></tr>
<tr class="separator:a8cf5dcebbeefc1670767ac619472e0bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a89ecd4bd0c30e8681bce57217b107502"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a89ecd4bd0c30e8681bce57217b107502">&#9670;&nbsp;</a></span>WebSocketInputStreambuf()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">WebSocketInputStreambuf::WebSocketInputStreambuf </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classSocket.html">Socket</a>&#160;</td>
          <td class="paramname"><em>socket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>dataLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>pMask</em> = <code>nullptr</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>bufferSize</em> = <code>2048</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a Web <a class="el" href="classSocket.html" title="Encapsulate a socket.">Socket</a> input record streambuf. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">socket</td><td>The socket we will be reading from. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLength</td><td>The size of a record. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">bufferSize</td><td>The size of the buffer we wish to allocate to hold data. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af91a50709423669d4ade7713a612dc64"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af91a50709423669d4ade7713a612dc64">&#9670;&nbsp;</a></span>discard()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WebSocketInputStreambuf::discard </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Discard data for the record that has not yet been read. </p>
<p>We are working on a logical fixed length record in a socket stream. This means that we know in advance how big the record should be. If we have read some data from the stream and no longer wish to consume any further, we have to discard the remaining bytes in the stream before we can get to process the next record. This function discards the remainder of the data.</p>
<p>For example, if our record size is 1000 bytes and we have read 700 bytes and determine that we no longer need to continue, we can't just stop. There are still 300 bytes in the socket stream that need to be consumed/discarded before we can move on to the next record. </p>

</div>
</div>
<a id="a8cf5dcebbeefc1670767ac619472e0bb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8cf5dcebbeefc1670767ac619472e0bb">&#9670;&nbsp;</a></span>getRecordSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t WebSocketInputStreambuf::getRecordSize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the size of the expected record. </p>
<dl class="section return"><dt>Returns</dt><dd>The size of the expected record. </dd></dl>

</div>
</div>
<a id="aed7065a593c58510569031142ce62e94"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aed7065a593c58510569031142ce62e94">&#9670;&nbsp;</a></span>underflow()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">WebSocketInputStreambuf::int_type WebSocketInputStreambuf::underflow </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Handle the request to read data from the stream but we need more data from the source. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="WebSocket_8h_source.html">WebSocket.h</a></li>
<li>WebSocket.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
